#!/bin/sh
EXEFOLDER=exe
mkdir ../$EXEFOLDER
gcc -O3 -I utilities -I datamining/correlation utilities/polybench.c datamining/correlation/correlation.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/correlation_O3 -lm
gcc -O3 -I utilities -I datamining/covariance utilities/polybench.c datamining/covariance/covariance.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/covariance_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/2mm utilities/polybench.c linear-algebra/kernels/2mm/2mm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/2mm_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/3mm utilities/polybench.c linear-algebra/kernels/3mm/3mm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/3mm_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/atax utilities/polybench.c linear-algebra/kernels/atax/atax.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/atax_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/bicg utilities/polybench.c linear-algebra/kernels/bicg/bicg.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/bicg_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/cholesky utilities/polybench.c linear-algebra/kernels/cholesky/cholesky.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/cholesky_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/doitgen utilities/polybench.c linear-algebra/kernels/doitgen/doitgen.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/doitgen_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/gemm utilities/polybench.c linear-algebra/kernels/gemm/gemm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gemm_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/gemver utilities/polybench.c linear-algebra/kernels/gemver/gemver.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gemver_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/gesummv utilities/polybench.c linear-algebra/kernels/gesummv/gesummv.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gesummv_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/mvt utilities/polybench.c linear-algebra/kernels/mvt/mvt.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/mvt_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/symm utilities/polybench.c linear-algebra/kernels/symm/symm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/symm_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/syr2k utilities/polybench.c linear-algebra/kernels/syr2k/syr2k.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/syr2k_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/syrk utilities/polybench.c linear-algebra/kernels/syrk/syrk.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/syrk_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/trisolv utilities/polybench.c linear-algebra/kernels/trisolv/trisolv.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/trisolv_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/trmm utilities/polybench.c linear-algebra/kernels/trmm/trmm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/trmm_O3 -lm
gcc -O3 -I utilities -I linear-algebra/solvers/durbin utilities/polybench.c linear-algebra/solvers/durbin/durbin.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/durbin_O3 -lm
gcc -O3 -I utilities -I linear-algebra/solvers/dynprog utilities/polybench.c linear-algebra/solvers/dynprog/dynprog.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/dynprog_O3 -lm
gcc -O3 -I utilities -I linear-algebra/solvers/gramschmidt utilities/polybench.c linear-algebra/solvers/gramschmidt/gramschmidt.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gramschmidt_O3 -lm
gcc -O3 -I utilities -I linear-algebra/solvers/lu utilities/polybench.c linear-algebra/solvers/lu/lu.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/lu_O3 -lm
gcc -O3 -I utilities -I linear-algebra/solvers/ludcmp utilities/polybench.c linear-algebra/solvers/ludcmp/ludcmp.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/ludcmp_O3 -lm
gcc -O3 -I utilities -I medley/floyd-warshall utilities/polybench.c medley/floyd-warshall/floyd-warshall.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/floyd-warshall_O3 -lm
gcc -O3 -I utilities -I medley/reg_detect utilities/polybench.c medley/reg_detect/reg_detect.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/reg_detect_O3 -lm
gcc -O3 -I utilities -I stencils/adi utilities/polybench.c stencils/adi/adi.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/adi_O3 -lm
gcc -O3 -I utilities -I stencils/fdtd-2d utilities/polybench.c stencils/fdtd-2d/fdtd-2d.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/fdtd-2d_O3 -lm
gcc -O3 -I utilities -I stencils/fdtd-apml utilities/polybench.c stencils/fdtd-apml/fdtd-apml.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/fdtd-apml_O3 -lm
gcc -O3 -I utilities -I stencils/jacobi-1d-imper utilities/polybench.c stencils/jacobi-1d-imper/jacobi-1d-imper.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/jacobi-1d-imper_O3 -lm
gcc -O3 -I utilities -I stencils/jacobi-2d-imper utilities/polybench.c stencils/jacobi-2d-imper/jacobi-2d-imper.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/jacobi-2d-imper_O3 -lm
gcc -O3 -I utilities -I stencils/seidel-2d utilities/polybench.c stencils/seidel-2d/seidel-2d.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/seidel-2d_O3 -lm

gcc -O0 -I utilities -I datamining/correlation utilities/polybench.c datamining/correlation/correlation.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/correlation_O0 -lm
gcc -O0 -I utilities -I datamining/covariance utilities/polybench.c datamining/covariance/covariance.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/covariance_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/2mm utilities/polybench.c linear-algebra/kernels/2mm/2mm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/2mm_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/3mm utilities/polybench.c linear-algebra/kernels/3mm/3mm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/3mm_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/atax utilities/polybench.c linear-algebra/kernels/atax/atax.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/atax_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/bicg utilities/polybench.c linear-algebra/kernels/bicg/bicg.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/bicg_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/cholesky utilities/polybench.c linear-algebra/kernels/cholesky/cholesky.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/cholesky_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/doitgen utilities/polybench.c linear-algebra/kernels/doitgen/doitgen.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/doitgen_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/gemm utilities/polybench.c linear-algebra/kernels/gemm/gemm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gemm_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/gemver utilities/polybench.c linear-algebra/kernels/gemver/gemver.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gemver_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/gesummv utilities/polybench.c linear-algebra/kernels/gesummv/gesummv.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gesummv_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/mvt utilities/polybench.c linear-algebra/kernels/mvt/mvt.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/mvt_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/symm utilities/polybench.c linear-algebra/kernels/symm/symm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/symm_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/syr2k utilities/polybench.c linear-algebra/kernels/syr2k/syr2k.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/syr2k_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/syrk utilities/polybench.c linear-algebra/kernels/syrk/syrk.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/syrk_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/trisolv utilities/polybench.c linear-algebra/kernels/trisolv/trisolv.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/trisolv_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/trmm utilities/polybench.c linear-algebra/kernels/trmm/trmm.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/trmm_O0 -lm
gcc -O0 -I utilities -I linear-algebra/solvers/durbin utilities/polybench.c linear-algebra/solvers/durbin/durbin.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/durbin_O0 -lm
gcc -O0 -I utilities -I linear-algebra/solvers/dynprog utilities/polybench.c linear-algebra/solvers/dynprog/dynprog.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/dynprog_O0 -lm
gcc -O0 -I utilities -I linear-algebra/solvers/gramschmidt utilities/polybench.c linear-algebra/solvers/gramschmidt/gramschmidt.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/gramschmidt_O0 -lm
gcc -O0 -I utilities -I linear-algebra/solvers/lu utilities/polybench.c linear-algebra/solvers/lu/lu.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/lu_O0 -lm
gcc -O0 -I utilities -I linear-algebra/solvers/ludcmp utilities/polybench.c linear-algebra/solvers/ludcmp/ludcmp.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/ludcmp_O0 -lm
gcc -O0 -I utilities -I medley/floyd-warshall utilities/polybench.c medley/floyd-warshall/floyd-warshall.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/floyd-warshall_O0 -lm
gcc -O0 -I utilities -I medley/reg_detect utilities/polybench.c medley/reg_detect/reg_detect.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/reg_detect_O0 -lm
gcc -O0 -I utilities -I stencils/adi utilities/polybench.c stencils/adi/adi.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/adi_O0 -lm
gcc -O0 -I utilities -I stencils/fdtd-2d utilities/polybench.c stencils/fdtd-2d/fdtd-2d.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/fdtd-2d_O0 -lm
gcc -O0 -I utilities -I stencils/fdtd-apml utilities/polybench.c stencils/fdtd-apml/fdtd-apml.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/fdtd-apml_O0 -lm
gcc -O0 -I utilities -I stencils/jacobi-1d-imper utilities/polybench.c stencils/jacobi-1d-imper/jacobi-1d-imper.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/jacobi-1d-imper_O0 -lm
gcc -O0 -I utilities -I stencils/jacobi-2d-imper utilities/polybench.c stencils/jacobi-2d-imper/jacobi-2d-imper.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/jacobi-2d-imper_O0 -lm
gcc -O0 -I utilities -I stencils/seidel-2d utilities/polybench.c stencils/seidel-2d/seidel-2d.c -DPOLYBENCH_TIME -fopenmp -o $EXEFOLDER/seidel-2d_O0 -lm
