#!/bin/sh
EXEFOLDER=exelarge
mkdir ./$EXEFOLDER
gcc -O3 -I utilities -I linear-algebra/kernels/atax utilities/polybench.c linear-algebra/kernels/atax/atax.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/atax_O3 -lm
gcc -O3 -I utilities -I linear-algebra/kernels/bicg utilities/polybench.c linear-algebra/kernels/bicg/bicg.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/bicg_O3 -lm
gcc -O3 -I utilities -I linear-algebra/solvers/durbin utilities/polybench.c linear-algebra/solvers/durbin/durbin.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/durbin_O3 -lm
gcc -O3 -I utilities -I stencils/jacobi-2d-imper utilities/polybench.c stencils/jacobi-2d-imper/jacobi-2d-imper.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/jacobi-2d-imper_O3 -lm

gcc -O0 -I utilities -I linear-algebra/kernels/atax utilities/polybench.c linear-algebra/kernels/atax/atax.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/atax_O0 -lm
gcc -O0 -I utilities -I linear-algebra/kernels/bicg utilities/polybench.c linear-algebra/kernels/bicg/bicg.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/bicg_O0 -lm
gcc -O0 -I utilities -I linear-algebra/solvers/durbin utilities/polybench.c linear-algebra/solvers/durbin/durbin.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/durbin_O0 -lm
gcc -O0 -I utilities -I stencils/jacobi-2d-imper utilities/polybench.c stencils/jacobi-2d-imper/jacobi-2d-imper.c -DPOLYBENCH_TIME -DLARGE_DATASET -fopenmp -o $EXEFOLDER/jacobi-2d-imper_O0 -lm
