JAVA=/usr/lib/jvm/java-8-oracle/bin/java
JOMP=../lib/jomp1.0b.jar
MAX_THREADS=16
FILE=../resuls.csv
declare -a benchmarks=("PDcorrelationJomp" "PDcovarianceJomp" "PL2mmJomp" "PL3mmJomp" "PLataxJomp" 
			"PLbicgJomp" "PLcholeskyJomp" "PLdoitgenJomp" "PLdurbinJomp" "PLdynprogJomp" 
			"PLgemmJomp" "PLgemverJomp" "PLgesummvJomp" "PLgramschmidtJomp" "PLludcmpJomp" 
			"PLluJomp" "PLmvtJomp" "PLsymmJomp" "PLsyr2kJomp" "PLsyrkJomp" 
			"PSfdtd_2dJomp" "PSfdtd_apmlJomp" "PSjacobi_1d_imperJomp" "PSjacobi_2d_imperJomp" "PSseidel_2dJomp" 
			"PLtrisolvJomp" "PLtrmmJomp" "PMfloydWarshallJomp" "PMreg_detectJomp" "PSadiJomp")

#create new result file
if [ -f  $FILE ];
then
   rm $FILE
else
   touch $FILE
   echo "benchmark, nthreads, time" >> $FILE
fi

START_TIME=`date`
## now loop
for BENCHMARK in "${benchmarks[@]}"
do
 echo "benchmark" $BENCHMARK "is running.."
  for NUM_THREADS in $(seq 1 $MAX_THREADS);
  do
    #echo $JAVA -cp $PYJAMA:. $BENCHMARK STANDARD $NUM_THREADS
    echo "current number of threads" $NUM_THREADS
    echo "$BENCHMARK, $NUM_THREADS, `$JAVA -cp $JOMP:. -Djomp.threads=$NUM_THREADS $BENCHMARK STANDARD 0`" >> $FILE
  done
done

echo "benchmark finished. started at $START_TIME, finished at `date`"
