
public class PDcovarianceJomp {


	public static int threadNumber = 4;
	public static double float_n;
	/* Array initialization. */
	public static void init_array(int m, int n,
			double[][] data, int M, int N) {
		int i;
		int j;

		float_n = 1.2;

		for (i = 0; i < M; i++) {
			for (j = 0; j < N; j++) {
				data[i][j] = ((double) i * j) / M;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int m, double[][] symmat)

	{
		int i;
		int j;

		for (i = 0; i < m; i++) {
			for (j = 0; j < m; j++) {
				System.out.printf("%.2f ", symmat[i][j]);
				if ((i * m + j) % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_covariance(int m, int n, double float_n,
			double[][] data, double[][] symmat, double[] mean) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.symmat = symmat;
  __omp_Object0.mean = mean;
  __omp_Object0.data = data;
  __omp_Object0.float_n = float_n;
  __omp_Object0.m = m;
  __omp_Object0.n = n;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  symmat = __omp_Object0.symmat;
  mean = __omp_Object0.mean;
  data = __omp_Object0.data;
  float_n = __omp_Object0.float_n;
  m = __omp_Object0.m;
  n = __omp_Object0.n;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int N, M;
		switch (dataSet) {
		case "MINI":
			N = 32;
			M = 32;
			break;
		case "SMALL":
			N = 500;
			M = 500;
			break;
		case "STANDARD":
		default:
			N = 1000;
			M = 1000;
			break;
		case "LARGE":
			N = 2000;
			M = 2000;
			break;
		case "EXTRALARGE":
			N = 4000;
			M = 4000;
			break;
		}
		int n = N;
		int m = M;

		/* Variable declaration/allocation. */
		double[][] data = new double[m][n];
		double[][] symmat = new double[m][m];
		double[] mean = new double[m];

		/* Initialize array(s). */
		PDcovarianceJomp.init_array(m, n, data, M, N);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PDcovarianceJomp.kernel_covariance(m, n, float_n, data, symmat, mean);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PDcovarianceJomp.print_array(m, symmat);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  double [ ] [ ] symmat;
  double [ ] mean;
  double [ ] [ ] data;
  double float_n;
  int m;
  int n;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( m);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int j = (int)__omp_ChunkData1.start; j < __omp_ChunkData1.stop; j += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			mean[j] = 0.0;
			for (int i = 0; i < n; i++) {
				mean[j] += data[i][j];
			}
			mean[j] /= float_n;
		}
                       // OMP USER CODE ENDS
                       if (j == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData5 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData4 = new jomp.runtime.LoopData();
                   __omp_WholeData5.start = (long)( 0);
                   __omp_WholeData5.stop = (long)( n);
                   __omp_WholeData5.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData5);
                   while(!__omp_ChunkData4.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData5, __omp_ChunkData4)) {
                   for(;;) {
                     if(__omp_WholeData5.step > 0) {
                        if(__omp_ChunkData4.stop > __omp_WholeData5.stop) __omp_ChunkData4.stop = __omp_WholeData5.stop;
                        if(__omp_ChunkData4.start >= __omp_WholeData5.stop) break;
                     } else {
                        if(__omp_ChunkData4.stop < __omp_WholeData5.stop) __omp_ChunkData4.stop = __omp_WholeData5.stop;
                        if(__omp_ChunkData4.start > __omp_WholeData5.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData4.start; i < __omp_ChunkData4.stop; i += __omp_ChunkData4.step) {
                       // OMP USER CODE BEGINS
 {
			for (int j = 0; j < m; j++) {
				data[i][j] -= mean[j];
			}
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData5.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData4.startStep == 0)
                       break;
                     __omp_ChunkData4.start += __omp_ChunkData4.startStep;
                     __omp_ChunkData4.stop += __omp_ChunkData4.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData8 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData7 = new jomp.runtime.LoopData();
                   __omp_WholeData8.start = (long)( 0);
                   __omp_WholeData8.stop = (long)( m);
                   __omp_WholeData8.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData8);
                   while(!__omp_ChunkData7.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData8, __omp_ChunkData7)) {
                   for(;;) {
                     if(__omp_WholeData8.step > 0) {
                        if(__omp_ChunkData7.stop > __omp_WholeData8.stop) __omp_ChunkData7.stop = __omp_WholeData8.stop;
                        if(__omp_ChunkData7.start >= __omp_WholeData8.stop) break;
                     } else {
                        if(__omp_ChunkData7.stop < __omp_WholeData8.stop) __omp_ChunkData7.stop = __omp_WholeData8.stop;
                        if(__omp_ChunkData7.start > __omp_WholeData8.stop) break;
                     }
                     for(int j1 = (int)__omp_ChunkData7.start; j1 < __omp_ChunkData7.stop; j1 += __omp_ChunkData7.step) {
                       // OMP USER CODE BEGINS
 {
			for (int j2 = j1; j2 < m; j2++) {
				symmat[j1][j2] = 0.0;
				for (int i = 0; i < n; i++) {
					symmat[j1][j2] += data[i][j1] * data[i][j2];
				}
				symmat[j2][j1] = symmat[j1][j2];
			}
		}
                       // OMP USER CODE ENDS
                       if (j1 == (__omp_WholeData8.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData7.startStep == 0)
                       break;
                     __omp_ChunkData7.start += __omp_ChunkData7.startStep;
                     __omp_ChunkData7.stop += __omp_ChunkData7.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

