
public class PLbicgJomp {


	public static int threadNumber = 4;
	/* Array initialization. */
	public static void init_array(int nx, int ny, double[][] A, double[] r,
			double[] p) {
		int i;
		int j;

		for (i = 0; i < ny; i++) {
			p[i] = i * Math.PI;
		}
		for (i = 0; i < nx; i++) {
			r[i] = i * Math.PI;
			for (j = 0; j < ny; j++) {
				A[i][j] = ((double) i * (j + 1)) / nx;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int nx, int ny, double[] s, double[] q)

	{
		int i;

		for (i = 0; i < ny; i++) {
			System.out.printf("%.2f ", s[i]);
			if (i % 20 == 0) {
				System.out.println();
			}
		}
		for (i = 0; i < nx; i++) {
			System.out.printf("%.2f ", q[i]);
			if (i % 20 == 0) {
				System.out.println();
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_bicg(int nx, int ny, double[][] A, double[] s,
			double[] q, double[] p, double[] r) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.nx = nx;
  __omp_Object0.ny = ny;
  __omp_Object0.p = p;
  __omp_Object0.q = q;
  __omp_Object0.r = r;
  __omp_Object0.s = s;
  __omp_Object0.A = A;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  nx = __omp_Object0.nx;
  ny = __omp_Object0.ny;
  p = __omp_Object0.p;
  q = __omp_Object0.q;
  r = __omp_Object0.r;
  s = __omp_Object0.s;
  A = __omp_Object0.A;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int NX, NY;
		switch (dataSet) {
		case "MINI":
			NX = 32;
			NY = 32;
			break;
		case "SMALL":
			NX = 500;
			NY = 500;
			break;
		case "STANDARD":
		default:
			NX = 4000;
			NY = 4000;
			break;
		case "LARGE":
			NX = 8000;
			NY = 8000;
			break;
		case "EXTRALARGE":
			NX = 100000;
			NY = 100000;
			break;
		}
		int nx = NX;
		int ny = NY;

		/* Variable declaration/allocation. */
		double[][] A = new double[nx][ny];
		double[] s = new double[ny];
		double[] q = new double[nx];
		double[] p = new double[ny];
		double[] r = new double[nx];

		/* Initialize array(s). */
		PLbicgJomp.init_array(nx, ny, A, r, p);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLbicgJomp.kernel_bicg(nx, ny, A, s, q, p, r);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLbicgJomp.print_array(nx, ny, s, q);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int nx;
  int ny;
  double [ ] p;
  double [ ] q;
  double [ ] r;
  double [ ] s;
  double [ ] [ ] A;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( ny);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData1.start; i < __omp_ChunkData1.stop; i += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			s[i] = 0;
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData5 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData4 = new jomp.runtime.LoopData();
                   __omp_WholeData5.start = (long)( 0);
                   __omp_WholeData5.stop = (long)( nx);
                   __omp_WholeData5.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData5);
                   while(!__omp_ChunkData4.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData5, __omp_ChunkData4)) {
                   for(;;) {
                     if(__omp_WholeData5.step > 0) {
                        if(__omp_ChunkData4.stop > __omp_WholeData5.stop) __omp_ChunkData4.stop = __omp_WholeData5.stop;
                        if(__omp_ChunkData4.start >= __omp_WholeData5.stop) break;
                     } else {
                        if(__omp_ChunkData4.stop < __omp_WholeData5.stop) __omp_ChunkData4.stop = __omp_WholeData5.stop;
                        if(__omp_ChunkData4.start > __omp_WholeData5.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData4.start; i < __omp_ChunkData4.stop; i += __omp_ChunkData4.step) {
                       // OMP USER CODE BEGINS
 {
			q[i] = 0;
			for (int j = 0; j < ny; j++) {
				s[j] = s[j] + r[i] * A[i][j];
				q[i] = q[i] + A[i][j] * p[j];
			}
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData5.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData4.startStep == 0)
                       break;
                     __omp_ChunkData4.start += __omp_ChunkData4.startStep;
                     __omp_ChunkData4.stop += __omp_ChunkData4.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

