
public class PLdoitgenJomp {


	public static int threadNumber = 4;
	/* Array initialization. */
	public static void init_array(int nr, int nq, int np, double[][][] A,
			double[][] C4) {
		int i;
		int j;
		int k;

		for (i = 0; i < nr; i++) {
			for (j = 0; j < nq; j++) {
				for (k = 0; k < np; k++) {
					A[i][j][k] = ((double) i * j + k) / np;
				}
			}
		}
		for (i = 0; i < np; i++) {
			for (j = 0; j < np; j++) {
				C4[i][j] = ((double) i * j) / np;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int nr, int nq, int np, double[][][] A) {
		int i;
		int j;
		int k;

		for (i = 0; i < nr; i++) {
			for (j = 0; j < nq; j++) {
				for (k = 0; k < np; k++) {
					System.out.printf("%.2f ", A[i][j][k]);
					if (i % 20 == 0) {
						System.out.println();
					}
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_doitgen(int nr, int nq, int np, double[][][] A,
			double[][] C4, double[][][] sum) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.np = np;
  __omp_Object0.nq = nq;
  __omp_Object0.nr = nr;
  __omp_Object0.sum = sum;
  __omp_Object0.A = A;
  __omp_Object0.C4 = C4;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  np = __omp_Object0.np;
  nq = __omp_Object0.nq;
  nr = __omp_Object0.nr;
  sum = __omp_Object0.sum;
  A = __omp_Object0.A;
  C4 = __omp_Object0.C4;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int NQ, NR, NP;
		switch (dataSet) {
		case "MINI":
			NQ = 10;
			NR = 10;
			NP = 10;
			break;
		case "SMALL":
			NQ = 32;
			NR = 32;
			NP = 32;
			break;
		case "STANDARD":
		default:
			NQ = 128;
			NR = 128;
			NP = 128;
			break;
		case "LARGE":
			NQ = 256;
			NR = 256;
			NP = 256;
			break;
		case "EXTRALARGE":
			NQ = 1000;
			NR = 1000;
			NP = 1000;
			break;
		}
		int nr = NR;
		int nq = NQ;
		int np = NP;

		/* Variable declaration/allocation. */
		double[][][] A = new double[nr][nq][np];
		double[][][] sum = new double[nr][nq][np];
		double[][] C4 = new double[np][np];

		/* Initialize array(s). */
		PLdoitgenJomp.init_array(nr, nq, np, A, C4);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLdoitgenJomp.kernel_doitgen(nr, nq, np, A, C4, sum);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLdoitgenJomp.print_array(nr, nq, np, A);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int np;
  int nq;
  int nr;
  double [ ] [ ] [ ] sum;
  double [ ] [ ] [ ] A;
  double [ ] [ ] C4;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( nr);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int r = (int)__omp_ChunkData1.start; r < __omp_ChunkData1.stop; r += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int q = 0; q < nq; q++) {
				for (int p = 0; p < np; p++) {
					sum[r][q][p] = 0;
					for (int s = 0; s < np; s++) {
						sum[r][q][p] = sum[r][q][p] + A[r][q][s] * C4[s][p];
					}
				}
				for (int p = 0; p < nr; p++) {
					A[r][q][p] = sum[r][q][p];
				}
			}
		}
                       // OMP USER CODE ENDS
                       if (r == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

