
public class PLdynprogJomp {


	public static int threadNumber = 4;
	public static int out;
	/* Array initialization. */
	public static void init_array(int length, int[][] c, int[][] W) {
		int i;
		int j;
		for (i = 0; i < length; i++) {
			for (j = 0; j < length; j++) {
				c[i][j] = i * j % 2;
				W[i][j] = ((int) i - j) / length;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int out) {
		System.out.printf("%d ", out);
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_dynprog(int tsteps, int length, int[][] c,
			int[][] W, int[][][] sum_c) {
		int out_l = 0;

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.tsteps = tsteps;
  __omp_Object0.length = length;
  __omp_Object0.c = c;
  __omp_Object0.W = W;
  __omp_Object0.sum_c = sum_c;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  out_l  += __omp_Object0._rd_out_l;
  // shared variables
  tsteps = __omp_Object0.tsteps;
  length = __omp_Object0.length;
  c = __omp_Object0.c;
  W = __omp_Object0.W;
  sum_c = __omp_Object0.sum_c;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

		out = out_l;
	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int LENGTH, TSTEPS;
		switch (dataSet) {
		case "MINI":
			TSTEPS = 10;
			LENGTH = 32;
			break;
		case "SMALL":
			TSTEPS = 100;
			LENGTH = 50;
			break;
		case "STANDARD":
		default:
			TSTEPS = 10000;
			LENGTH = 50;
			break;
		case "LARGE":
			TSTEPS = 1000;
			LENGTH = 500;
			break;
		case "EXTRALARGE":
			TSTEPS = 10000;
			LENGTH = 500;
			break;
		}
		int length = LENGTH;
		int tsteps = TSTEPS;

		/* Variable declaration/allocation. */
		int[][][] sum_c = new int[length][length][length];
		int[][] c = new int[length][length];
		int[][] W = new int[length][length];

		/* Initialize array(s). */
		PLdynprogJomp.init_array(length, c, W);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLdynprogJomp.kernel_dynprog(tsteps, length, c, W, sum_c);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLdynprogJomp.print_array(out);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int tsteps;
  int length;
  int [ ] [ ] c;
  int [ ] [ ] W;
  int [ ] [ ] [ ] sum_c;
  // firstprivate variables
  // variables to hold results of reduction
  int _rd_out_l;

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
  int out_l = 0;
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( tsteps);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int iter = (int)__omp_ChunkData1.start; iter < __omp_ChunkData1.stop; iter += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int i = 0; i <= length - 1; i++) {
				for (int j = 0; j <= length - 1; j++) {
					c[i][j] = 0;
				}
			}

			for (int i = 0; i <= length - 2; i++) {
				for (int j = i + 1; j <= length - 1; j++) {
					sum_c[i][j][i] = 0;
					for (int k = i + 1; k <= j - 1; k++) {
						sum_c[i][j][k] = sum_c[i][j][k - 1] + c[i][k] + c[k][j];
					}
					c[i][j] = sum_c[i][j][j - 1] + W[i][j];
				}
			}
			out_l += c[0][length - 1];
		}
                       // OMP USER CODE ENDS
                       if (iter == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  out_l = (int) jomp.runtime.OMP.doPlusReduce(__omp_me, out_l);
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
    _rd_out_l = out_l;
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

