
public class PLgemmJomp {


	public static int threadNumber = 4;
	public static double alpha, beta;
	/* Array initialization. */
	public static void init_array(int ni, int nj, int nk,
			double[][] C, double[][] A, double[][] B) {
		int i;
		int j;

		alpha = (double) 32412;
		beta = (double) 2123;
		for (i = 0; i < ni; i++) {
			for (j = 0; j < nj; j++) {
				C[i][j] = ((double) i * j) / ni;
			}
		}
		for (i = 0; i < ni; i++) {
			for (j = 0; j < nk; j++) {
				A[i][j] = ((double) i * j) / ni;
			}
		}
		for (i = 0; i < nk; i++) {
			for (j = 0; j < nj; j++) {
				B[i][j] = ((double) i * j) / ni;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int ni, int nj, double[][] C) {
		int i;
		int j;

		for (i = 0; i < ni; i++) {
			for (j = 0; j < nj; j++) {
				System.out.printf("%.2f ", C[i][j]);
				if ((i * ni + j) % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_gemm(int ni, int nj, int nk, double alpha,
			double beta, double[][] C, double[][] A, double[][] B) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.ni = ni;
  __omp_Object0.nj = nj;
  __omp_Object0.nk = nk;
  __omp_Object0.alpha = alpha;
  __omp_Object0.beta = beta;
  __omp_Object0.A = A;
  __omp_Object0.B = B;
  __omp_Object0.C = C;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  ni = __omp_Object0.ni;
  nj = __omp_Object0.nj;
  nk = __omp_Object0.nk;
  alpha = __omp_Object0.alpha;
  beta = __omp_Object0.beta;
  A = __omp_Object0.A;
  B = __omp_Object0.B;
  C = __omp_Object0.C;
}
// OMP PARALLEL BLOCK ENDS

		//#pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int NI, NJ, NK;
		switch (dataSet) {
		case "MINI":
			NI = 32;
			NJ = 32;
			NK = 32;
			break;
		case "SMALL":
			NI = 128;
			NJ = 128;
			NK = 128;
			break;
		case "STANDARD":
		default:
			NI = 1024;
			NJ = 1024;
			NK = 1024;
			break;
		case "LARGE":
			NI = 2000;
			NJ = 2000;
			NK = 2000;
			break;
		case "EXTRALARGE":
			NI = 4000;
			NJ = 4000;
			NK = 4000;
			break;
		}
		int ni = NI;
		int nj = NJ;
		int nk = NK;

		/* Variable declaration/allocation. */
		double[][] C = new double[ni][nj];
		double[][] A = new double[ni][nk];
		double[][] B = new double[nk][nj];

		/* Initialize array(s). */
		PLgemmJomp.init_array(ni, nj, nk, C, A, B);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLgemmJomp.kernel_gemm(ni, nj, nk, alpha, beta, C, A, B);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLgemmJomp.print_array(ni, nj, C);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int ni;
  int nj;
  int nk;
  double alpha;
  double beta;
  double [ ] [ ] A;
  double [ ] [ ] B;
  double [ ] [ ] C;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( ni);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData1.start; i < __omp_ChunkData1.stop; i += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int j = 0; j < nj; j++) {
				C[i][j] *= beta;
				for (int k = 0; k < nk; ++k) {
					C[i][j] += alpha * A[i][k] * B[k][j];
				}
			}
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

