
public class PLgesummvJomp {


	public static int threadNumber = 4;
	public static double alpha, beta;
	/* Array initialization. */
	public static void init_array(int n, double[][] A, double[][] B,
			double[] x) {
		int i;
		int j;

		alpha = (double) 43532;
		beta = (double) 12313;
		for (i = 0; i < n; i++) {
			x[i] = ((double) i) / n;
			for (j = 0; j < n; j++) {
				A[i][j] = ((double) i * j) / n;
				B[i][j] = ((double) i * j) / n;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int n, double[] y)

	{
		int i;

		for (i = 0; i < n; i++) {
			System.out.printf("%0.2lf ", y[i]);
			if (i % 20 == 0) {
				System.out.println();
			}
		}
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_gesummv(int n, double alpha, double beta,
			double[][] A, double[][] B, double[] tmp, double[] x, double[] y) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.n = n;
  __omp_Object0.tmp = tmp;
  __omp_Object0.x = x;
  __omp_Object0.y = y;
  __omp_Object0.A = A;
  __omp_Object0.B = B;
  __omp_Object0.alpha = alpha;
  __omp_Object0.beta = beta;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  n = __omp_Object0.n;
  tmp = __omp_Object0.tmp;
  x = __omp_Object0.x;
  y = __omp_Object0.y;
  A = __omp_Object0.A;
  B = __omp_Object0.B;
  alpha = __omp_Object0.alpha;
  beta = __omp_Object0.beta;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int N;
		switch (dataSet) {
		case "MINI":
			N = 32;
			break;
		case "SMALL":
			N = 500;
			break;
		case "STANDARD":
		default:
			N = 4000;
			break;
		case "LARGE":
			N = 8000;
			break;
		case "EXTRALARGE":
			N = 100000;
			break;
		}
		int n = N;

		/* Variable declaration/allocation. */
		double[][] A = new double[n][n];
		double[][] B = new double[n][n];
		double[] tmp = new double[n];
		double[] x = new double[n];
		double[] y = new double[n];

		/* Initialize array(s). */
		PLgesummvJomp.init_array(n, A, B, x);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLgesummvJomp.kernel_gesummv(n, alpha, beta, A, B, tmp, x, y);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLgesummvJomp.print_array(n, y);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int n;
  double [ ] tmp;
  double [ ] x;
  double [ ] y;
  double [ ] [ ] A;
  double [ ] [ ] B;
  double alpha;
  double beta;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( n);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData1.start; i < __omp_ChunkData1.stop; i += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			tmp[i] = 0;
			y[i] = 0;
			for (int j = 0; j < n; j++) {
				tmp[i] = A[i][j] * x[j] + tmp[i];
				y[i] = B[i][j] * x[j] + y[i];
			}
			y[i] = alpha * tmp[i] + beta * y[i];
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

