
public class PLgramschmidtJomp {


	public static int threadNumber = 4;
	/* Array initialization. */
	public static void init_array(int ni, int nj, double[][] A, double[][] R,
			double[][] Q) {
		int i;
		int j;

		for (i = 0; i < ni; i++) {
			for (j = 0; j < nj; j++) {
				A[i][j] = ((double) i * j) / ni;
				Q[i][j] = ((double) i * (j + 1)) / nj;
			}
		}
		for (i = 0; i < nj; i++) {
			for (j = 0; j < nj; j++) {
				R[i][j] = ((double) i * (j + 2)) / nj;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int ni, int nj, double[][] A, double[][] R,
			double[][] Q) {
		int i;
		int j;

		for (i = 0; i < ni; i++) {
			for (j = 0; j < nj; j++) {
				System.out.printf("%.2f ", A[i][j]);
				if (i % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
		for (i = 0; i < nj; i++) {
			for (j = 0; j < nj; j++) {
				System.out.printf("%.2f ", R[i][j]);
				if (i % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
		for (i = 0; i < ni; i++) {
			for (j = 0; j < nj; j++) {
				System.out.printf("%.2f ", Q[i][j]);
				if (i % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_gramschmidt(int ni, int nj, double[][] A,
			double[][] R, double[][] Q) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.ni = ni;
  __omp_Object0.nj = nj;
  __omp_Object0.A = A;
  __omp_Object0.R = R;
  __omp_Object0.Q = Q;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  ni = __omp_Object0.ni;
  nj = __omp_Object0.nj;
  A = __omp_Object0.A;
  R = __omp_Object0.R;
  Q = __omp_Object0.Q;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int NI, NJ;
		switch (dataSet) {
		case "MINI":
			NI = 32;
			NJ = 32;
			break;
		case "SMALL":
			NI = 128;
			NJ = 128;
			break;
		case "STANDARD":
		default:
			NI = 512;
			NJ = 512;
			break;
		case "LARGE":
			NI = 2000;
			NJ = 2000;
			break;
		case "EXTRALARGE":
			NI = 4000;
			NJ = 4000;
			break;
		}
		int ni = NI;
		int nj = NJ;

		/* Variable declaration/allocation. */
		double[][] A = new double[ni][nj];
		double[][] R = new double[nj][nj];
		double[][] Q = new double[ni][nj];

		/* Initialize array(s). */
		PLgramschmidtJomp.init_array(ni, nj, A, R, Q);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLgramschmidtJomp.kernel_gramschmidt(ni, nj, A, R, Q);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLgramschmidtJomp.print_array(ni, nj, A, R, Q);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int ni;
  int nj;
  double [ ] [ ] A;
  double [ ] [ ] R;
  double [ ] [ ] Q;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( nj);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int k = (int)__omp_ChunkData1.start; k < __omp_ChunkData1.stop; k += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			double nrm = 0;
			for (int i = 0; i < ni; i++) {
				nrm += A[i][k] * A[i][k];
			}
			R[k][k] = Math.sqrt(nrm);
			for (int i = 0; i < ni; i++) {
				Q[i][k] = A[i][k] / R[k][k];
			}
			for (int j = k + 1; j < nj; j++) {
				R[k][j] = 0;
				for (int i = 0; i < ni; i++) {
					R[k][j] += Q[i][k] * A[i][j];
				}
				for (int i = 0; i < ni; i++) {
					A[i][j] = A[i][j] - Q[i][k] * R[k][j];
				}
			}
		}
                       // OMP USER CODE ENDS
                       if (k == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

