
public class PLludcmpJomp {


	public static int threadNumber = 4;
	/* Array initialization. */
	public static void init_array(int n, double[][] A, double[] b, double[] x,
			double[] y) {
		int i;
		int j;

		for (i = 0; i <= n; i++) {
			x[i] = i + 1;
			y[i] = (i + 1) / n / 2.0 + 1;
			b[i] = (i + 1) / n / 2.0 + 42;
			for (j = 0; j <= n; j++) {
				A[i][j] = ((double) (i + 1) * (j + 1)) / n;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int n, double[] x)

	{
		int i;

		for (i = 0; i <= n; i++) {
			System.out.printf("%.2f ", x[i]);
			if (i % 20 == 0) {
				System.out.println();
			}
		}
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_ludcmp(int n, double[][] A, double[] b,
			double[] x, double[] y) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.n = n;
  __omp_Object0.A = A;
  __omp_Object0.b = b;
  __omp_Object0.x = x;
  __omp_Object0.y = y;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  n = __omp_Object0.n;
  A = __omp_Object0.A;
  b = __omp_Object0.b;
  x = __omp_Object0.x;
  y = __omp_Object0.y;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int N;
		switch (dataSet) {
		case "MINI":
			N = 32;
			break;
		case "SMALL":
			N = 128;
			break;
		case "STANDARD":
		default:
			N = 1024;
			break;
		case "LARGE":
			N = 2000;
			break;
		case "EXTRALARGE":
			N = 4000;
			break;
		}
		int n = N;

		/* Variable declaration/allocation. */
		double[][] A = new double[n + 1][n + 1];
		double[] b = new double[n + 1];
		double[] x = new double[n + 1];
		double[] y = new double[n + 1];

		/* Initialize array(s). */
		PLludcmpJomp.init_array(n, A, b, x, y);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PLludcmpJomp.kernel_ludcmp(n, A, b, x, y);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PLludcmpJomp.print_array(n, x);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int n;
  double [ ] [ ] A;
  double [ ] b;
  double [ ] x;
  double [ ] y;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
		double w;
		b[0] = 1.0;
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( n);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData1.start; i < __omp_ChunkData1.stop; i += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int j = i + 1; j <= n; j++) {
				w = A[j][i];
				for (int k = 0; k < i; k++) {
					w = w - A[j][k] * A[k][i];
				}
				A[j][i] = w / A[i][i];
			}
			for (int j = i + 1; j <= n; j++) {
				w = A[i + 1][j];
				for (int k = 0; k <= i; k++) {
					w = w - A[i + 1][k] * A[k][j];
				}
				A[i + 1][j] = w;
			}
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		y[0] = b[0];
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData5 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData4 = new jomp.runtime.LoopData();
                   __omp_WholeData5.start = (long)( 1);
                   __omp_WholeData5.stop = (long)( n)+1;
                   __omp_WholeData5.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData5);
                   while(!__omp_ChunkData4.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData5, __omp_ChunkData4)) {
                   for(;;) {
                     if(__omp_WholeData5.step > 0) {
                        if(__omp_ChunkData4.stop > __omp_WholeData5.stop) __omp_ChunkData4.stop = __omp_WholeData5.stop;
                        if(__omp_ChunkData4.start >= __omp_WholeData5.stop) break;
                     } else {
                        if(__omp_ChunkData4.stop < __omp_WholeData5.stop) __omp_ChunkData4.stop = __omp_WholeData5.stop;
                        if(__omp_ChunkData4.start > __omp_WholeData5.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData4.start; i < __omp_ChunkData4.stop; i += __omp_ChunkData4.step) {
                       // OMP USER CODE BEGINS
 {
			w = b[i];
			for (int j = 0; j < i; j++) {
				w = w - A[i][j] * y[j];
			}
			y[i] = w;
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData5.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData4.startStep == 0)
                       break;
                     __omp_ChunkData4.start += __omp_ChunkData4.startStep;
                     __omp_ChunkData4.stop += __omp_ChunkData4.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		x[n] = y[n] / A[n][n];
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData8 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData7 = new jomp.runtime.LoopData();
                   __omp_WholeData8.start = (long)( 0);
                   __omp_WholeData8.stop = (long)( (n - 1))+1;
                   __omp_WholeData8.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData8);
                   while(!__omp_ChunkData7.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData8, __omp_ChunkData7)) {
                   for(;;) {
                     if(__omp_WholeData8.step > 0) {
                        if(__omp_ChunkData7.stop > __omp_WholeData8.stop) __omp_ChunkData7.stop = __omp_WholeData8.stop;
                        if(__omp_ChunkData7.start >= __omp_WholeData8.stop) break;
                     } else {
                        if(__omp_ChunkData7.stop < __omp_WholeData8.stop) __omp_ChunkData7.stop = __omp_WholeData8.stop;
                        if(__omp_ChunkData7.start > __omp_WholeData8.stop) break;
                     }
                     for(int i = (int)__omp_ChunkData7.start; i < __omp_ChunkData7.stop; i += __omp_ChunkData7.step) {
                       // OMP USER CODE BEGINS
 {
			w = y[n - 1 - (i)];
			for (int j = n - i; j <= n; j++) {
				w = w - A[n - 1 - i][j] * x[j];
			}
			x[n - 1 - i] = w / A[n - 1 - (i)][n - 1 - (i)];
		}
                       // OMP USER CODE ENDS
                       if (i == (__omp_WholeData8.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData7.startStep == 0)
                       break;
                     __omp_ChunkData7.start += __omp_ChunkData7.startStep;
                     __omp_ChunkData7.stop += __omp_ChunkData7.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

