
public class PMfloydWarshallJomp {


	public static int threadNumber = 4;
	/* Array initialization. */
	public static void init_array(int n, double[][] path) {
		int i;
		int j;

		for (i = 0; i < n; i++) {
			for (j = 0; j < n; j++) {
				path[i][j] = ((double) (i + 1) * (j + 1)) / n;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int n, double[][] path)

	{
		int i;
		int j;

		for (i = 0; i < n; i++) {
			for (j = 0; j < n; j++) {
				System.out.printf("%.2f ", path[i][j]);
				if ((i * n + j) % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_floyd_warshall(int n, double[][] path) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.n = n;
  __omp_Object0.path = path;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  n = __omp_Object0.n;
  path = __omp_Object0.path;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int N;
		switch (dataSet) {
		case "MINI":
			N = 32;
			break;
		case "SMALL":
			N = 128;
			break;
		case "STANDARD":
		default:
			N = 1024;
			break;
		case "LARGE":
			N = 2000;
			break;
		case "EXTRALARGE":
			N = 4000;
			break;
		}
		int n = N;

		/* Variable declaration/allocation. */
		double[][] path = new double[n][n];

		/* Initialize array(s). */
		PMfloydWarshallJomp.init_array(n, path);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PMfloydWarshallJomp.kernel_floyd_warshall(n, path);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PMfloydWarshallJomp.print_array(n, path);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int n;
  double [ ] [ ] path;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( n);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int k = (int)__omp_ChunkData1.start; k < __omp_ChunkData1.stop; k += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					path[i][j] = path[i][j] < path[i][k] + path[k][j] ? path[i][j]
							: path[i][k] + path[k][j];
				}
			}
		}
                       // OMP USER CODE ENDS
                       if (k == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

