
public class PMreg_detectJomp {


	public static int threadNumber = 4;
	/* Array initialization. */
	public static void init_array(int maxgrid, int[][] sum_tang, int[][] mean,
			int[][] path) {
		int i;
		int j;

		for (i = 0; i < maxgrid; i++) {
			for (j = 0; j < maxgrid; j++) {
				sum_tang[i][j] = (int) ((i + 1) * (j + 1));
				mean[i][j] = ((int) i - j) / maxgrid;
				path[i][j] = ((int) i * (j - 1)) / maxgrid;
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int maxgrid, int[][] path) {
		int i;
		int j;

		for (i = 0; i < maxgrid; i++) {
			for (j = 0; j < maxgrid; j++) {
				System.out.printf("%.2f ", path[i][j]);
				if ((i * maxgrid + j) % 20 == 0) {
					System.out.println();
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	/* Source (modified): http://www.cs.uic.edu/~iluican/reg_detect.c */
	public static void kernel_reg_detect(int niter, int maxgrid, int length,
			int[][] sum_tang, int[][] mean, int[][] path, int[][][] diff,
			int[][][] sum_diff) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.niter = niter;
  __omp_Object0.maxgrid = maxgrid;
  __omp_Object0.length = length;
  __omp_Object0.diff = diff;
  __omp_Object0.sum_tang = sum_tang;
  __omp_Object0.sum_diff = sum_diff;
  __omp_Object0.mean = mean;
  __omp_Object0.path = path;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  niter = __omp_Object0.niter;
  maxgrid = __omp_Object0.maxgrid;
  length = __omp_Object0.length;
  diff = __omp_Object0.diff;
  sum_tang = __omp_Object0.sum_tang;
  sum_diff = __omp_Object0.sum_diff;
  mean = __omp_Object0.mean;
  path = __omp_Object0.path;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int NITER, LENGTH, MAXGRID;
		switch (dataSet) {
		case "MINI":
			NITER = 10;
			LENGTH = 32;
			MAXGRID = 2;
			break;
		case "SMALL":
			NITER = 100;
			LENGTH = 50;
			MAXGRID = 6;
			break;
		case "STANDARD":
		default:
			NITER = 10000;
			LENGTH = 64;
			MAXGRID = 6;
			break;
		case "LARGE":
			NITER = 1000;
			LENGTH = 500;
			MAXGRID = 12;
			break;
		case "EXTRALARGE":
			NITER = 10000;
			LENGTH = 500;
			MAXGRID = 12;
			break;
		}
		int niter = NITER;
		int maxgrid = MAXGRID;
		int length = LENGTH;

		/* Variable declaration/allocation. */
		int[][] sum_tang = new int[maxgrid][maxgrid];
		int[][] mean = new int[maxgrid][maxgrid];
		int[][] path = new int[maxgrid][maxgrid];
		int[][][] diff = new int[maxgrid][maxgrid][length];
		int[][][] sum_diff = new int[maxgrid][maxgrid][length];

		/* Initialize array(s). */
		PMreg_detectJomp.init_array(maxgrid, sum_tang, mean, path);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PMreg_detectJomp.kernel_reg_detect(niter, maxgrid, length, sum_tang, mean,
				path, diff, sum_diff);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PMreg_detectJomp.print_array(maxgrid, path);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int niter;
  int maxgrid;
  int length;
  int [ ] [ ] [ ] diff;
  int [ ] [ ] sum_tang;
  int [ ] [ ] [ ] sum_diff;
  int [ ] [ ] mean;
  int [ ] [ ] path;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( niter);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int t = (int)__omp_ChunkData1.start; t < __omp_ChunkData1.stop; t += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int j = 0; j <= maxgrid - 1; j++) {
				for (int i = j; i <= maxgrid - 1; i++) {
					for (int cnt = 0; cnt <= length - 1; cnt++) {
						diff[j][i][cnt] = sum_tang[j][i];
					}
				}
			}

			for (int j = 0; j <= maxgrid - 1; j++) {
				for (int i = j; i <= maxgrid - 1; i++) {
					sum_diff[j][i][0] = diff[j][i][0];
					for (int cnt = 1; cnt <= length - 1; cnt++) {
						sum_diff[j][i][cnt] = sum_diff[j][i][cnt - 1]
								+ diff[j][i][cnt];
					}
					mean[j][i] = sum_diff[j][i][length - 1];
				}
			}

			for (int i = 0; i <= maxgrid - 1; i++) {
				path[0][i] = mean[0][i];
			}

			for (int j = 1; j <= maxgrid - 1; j++) {
				for (int i = j; i <= maxgrid - 1; i++) {
					path[j][i] = path[j - 1][i - 1] + mean[j][i];
				}
			}
		}
                       // OMP USER CODE ENDS
                       if (t == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

