
public class PSfdtd_apmlJomp {


	public static int threadNumber = 4;
	public static double mui, ch;
	/* Array initialization. */
	public static void init_array(int cz, int cxm, int cym,
			double[][] Ax, double[][] Ry, double[][][] Ex, double[][][] Ey,
			double[][][] Hz, double[] czm, double[] czp, double[] cxmh,
			double[] cxph, double[] cymh, double[] cyph) {
		int i;
		int j;
		int k;
		mui = (double) 2341;
		ch = (double) 42;
		for (i = 0; i <= cz; i++) {
			czm[i] = ((double) i + 1) / cxm;
			czp[i] = ((double) i + 2) / cxm;
		}
		for (i = 0; i <= cxm; i++) {
			cxmh[i] = ((double) i + 3) / cxm;
			cxph[i] = ((double) i + 4) / cxm;
		}
		for (i = 0; i <= cym; i++) {
			cymh[i] = ((double) i + 5) / cxm;
			cyph[i] = ((double) i + 6) / cxm;
		}

		for (i = 0; i <= cz; i++) {
			for (j = 0; j <= cym; j++) {
				Ry[i][j] = ((double) i * (j + 1) + 10) / cym;
				Ax[i][j] = ((double) i * (j + 2) + 11) / cym;
				for (k = 0; k <= cxm; k++) {
					Ex[i][j][k] = ((double) i * (j + 3) + k + 1) / cxm;
					Ey[i][j][k] = ((double) i * (j + 4) + k + 2) / cym;
					Hz[i][j][k] = ((double) i * (j + 5) + k + 3) / cz;
				}
			}
		}
	}

	/*
	 * DCE code. Must scan the entire live-out data. Can be used also to check
	 * the correctness of the output.
	 */
	public static void print_array(int cz, int cxm, int cym, double[][][] Bza,
			double[][][] Ex, double[][][] Ey, double[][][] Hz) {
		int i;
		int j;
		int k;

		for (i = 0; i <= cz; i++) {
			for (j = 0; j <= cym; j++) {
				for (k = 0; k <= cxm; k++) {
					System.out.printf("%0.2lf ", Bza[i][j][k]);
					System.out.printf("%0.2lf ", Ex[i][j][k]);
					System.out.printf("%0.2lf ", Ey[i][j][k]);
					System.out.printf("%0.2lf ", Hz[i][j][k]);
					if ((i * cxm + j) % 20 == 0) {
						System.out.println();
					}
				}
			}
		}
		System.out.println();
	}

	/*
	 * Main computational kernel. The whole function will be timed, including
	 * the call and return.
	 */
	public static void kernel_fdtd_apml(int cz, int cxm, int cym, double mui,
			double ch, double[][] Ax, double[][] Ry, double[][] clf,
			double[][] tmp, double[][][] Bza, double[][][] Ex, double[][][] Ey,
			double[][][] Hz, double[] czm, double[] czp, double[] cxmh,
			double[] cxph, double[] cymh, double[] cyph) {

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.cz = cz;
  __omp_Object0.cym = cym;
  __omp_Object0.cxm = cxm;
  __omp_Object0.clf = clf;
  __omp_Object0.Ex = Ex;
  __omp_Object0.Ey = Ey;
  __omp_Object0.tmp = tmp;
  __omp_Object0.cymh = cymh;
  __omp_Object0.cyph = cyph;
  __omp_Object0.Bza = Bza;
  __omp_Object0.ch = ch;
  __omp_Object0.cxmh = cxmh;
  __omp_Object0.cxph = cxph;
  __omp_Object0.Hz = Hz;
  __omp_Object0.Ax = Ax;
  __omp_Object0.mui = mui;
  __omp_Object0.czp = czp;
  __omp_Object0.czm = czm;
  __omp_Object0.Ry = Ry;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  cz = __omp_Object0.cz;
  cym = __omp_Object0.cym;
  cxm = __omp_Object0.cxm;
  clf = __omp_Object0.clf;
  Ex = __omp_Object0.Ex;
  Ey = __omp_Object0.Ey;
  tmp = __omp_Object0.tmp;
  cymh = __omp_Object0.cymh;
  cyph = __omp_Object0.cyph;
  Bza = __omp_Object0.Bza;
  ch = __omp_Object0.ch;
  cxmh = __omp_Object0.cxmh;
  cxph = __omp_Object0.cxph;
  Hz = __omp_Object0.Hz;
  Ax = __omp_Object0.Ax;
  mui = __omp_Object0.mui;
  czp = __omp_Object0.czp;
  czm = __omp_Object0.czm;
  Ry = __omp_Object0.Ry;
}
// OMP PARALLEL BLOCK ENDS

		// #pragma endscop

	}

	public static void main(String[] args) {
		/* Retrieve problem size. */
		String dataSet;
		if (args.length == 2) {
			dataSet = args[0].toUpperCase();
			threadNumber = Integer.parseInt(args[1]);
		} else if (args.length == 1) {
			dataSet = args[0].toUpperCase();
		} else {
			dataSet = "STANDARD";
		}
		int CZ, CYM, CXM;
		switch (dataSet) {
		case "MINI":
			CZ = 32;
			CYM = 32;
			CXM = 32;
			break;
		case "SMALL":
			CZ = 64;
			CYM = 64;
			CXM = 64;
			break;
		case "STANDARD":
		default:
			CZ = 256;
			CYM = 256;
			CXM = 256;
			break;
		case "LARGE":
			CZ = 512;
			CYM = 512;
			CXM = 512;
			break;
		case "EXTRALARGE":
			CZ = 1000;
			CYM = 1000;
			CXM = 1000;
			break;
		}
		int cz = CZ;
		int cym = CYM;
		int cxm = CXM;

		/* Variable declaration/allocation. */
		double[][] Ax = new double[cz + 1][cym + 1];
		double[][] Ry = new double[cz + 1][cym + 1];
		double[][] clf = new double[cym + 1][cxm + 1];
		double[][] tmp = new double[cym + 1][cxm + 1];
		double[][][] Bza = new double[cz + 1][cym + 1][cxm + 1];
		double[][][] Ex = new double[cz + 1][cym + 1][cxm + 1];
		double[][][] Ey = new double[cz + 1][cym + 1][cxm + 1];
		double[][][] Hz = new double[cz + 1][cym + 1][cxm + 1];
		double[] czm = new double[cz + 1];
		double[] czp = new double[cz + 1];
		double[] cxmh = new double[cxm + 1];
		double[] cxph = new double[cxm + 1];
		double[] cymh = new double[cxm + 1];
		double[] cyph = new double[cxm + 1];

		/* Initialize array(s). */
		PSfdtd_apmlJomp.init_array(cz, cxm, cym, Ax, Ry,
				Ex, Ey, Hz, czm, czp, cxmh, cxph, cymh, cyph);

		/* Start timer. */
		long pre = System.currentTimeMillis();

		/* Run kernel. */
		PSfdtd_apmlJomp.kernel_fdtd_apml(cz, cxm, cym, mui, ch, Ax, Ry, clf, tmp,
				Bza, Ex, Ey, Hz, czm, czp, cxmh, cxph, cymh, cyph);

		/* Stop and print timer. */
		long pos = System.currentTimeMillis();
		System.out.print(pos - pre);

		/*
		 * Prevent dead-code elimination. All live-out data must be printed by
		 * the function call in argument.
		 */
		// PSfdtd_apmlJomp.print_array(cz, cxm, cym, Bza, Ex, Ey, Hz);

	}

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  int cz;
  int cym;
  int cxm;
  double [ ] [ ] clf;
  double [ ] [ ] [ ] Ex;
  double [ ] [ ] [ ] Ey;
  double [ ] [ ] tmp;
  double [ ] cymh;
  double [ ] cyph;
  double [ ] [ ] [ ] Bza;
  double ch;
  double [ ] cxmh;
  double [ ] cxph;
  double [ ] [ ] [ ] Hz;
  double [ ] [ ] Ax;
  double mui;
  double [ ] czp;
  double [ ] czm;
  double [ ] [ ] Ry;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS
 
		{
                 { // OMP FOR BLOCK BEGINS
                 // copy of firstprivate variables, initialized
                 // copy of lastprivate variables
                 // variables to hold result of reduction
                 boolean amLast=false;
                 {
                   // firstprivate variables + init
                   // [last]private variables
                   // reduction variables + init to default
                   // -------------------------------------
                   jomp.runtime.LoopData __omp_WholeData2 = new jomp.runtime.LoopData();
                   jomp.runtime.LoopData __omp_ChunkData1 = new jomp.runtime.LoopData();
                   __omp_WholeData2.start = (long)( 0);
                   __omp_WholeData2.stop = (long)( cz);
                   __omp_WholeData2.step = (long)(1);
                   jomp.runtime.OMP.setChunkStatic(__omp_WholeData2);
                   while(!__omp_ChunkData1.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData2, __omp_ChunkData1)) {
                   for(;;) {
                     if(__omp_WholeData2.step > 0) {
                        if(__omp_ChunkData1.stop > __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start >= __omp_WholeData2.stop) break;
                     } else {
                        if(__omp_ChunkData1.stop < __omp_WholeData2.stop) __omp_ChunkData1.stop = __omp_WholeData2.stop;
                        if(__omp_ChunkData1.start > __omp_WholeData2.stop) break;
                     }
                     for(int iz = (int)__omp_ChunkData1.start; iz < __omp_ChunkData1.stop; iz += __omp_ChunkData1.step) {
                       // OMP USER CODE BEGINS
 {
			for (int iy = 0; iy < cym; iy++) {
				for (int ix = 0; ix < cxm; ix++) {
					clf[iz][iy] = Ex[iz][iy][ix] - Ex[iz][iy + 1][ix]
							+ Ey[iz][iy][ix + 1] - Ey[iz][iy][ix];
					tmp[iz][iy] = (cymh[iy] / cyph[iy]) * Bza[iz][iy][ix]
							- (ch / cyph[iy]) * clf[iz][iy];
					Hz[iz][iy][ix] = (cxmh[ix] / cxph[ix]) * Hz[iz][iy][ix]
							+ (mui * czp[iz] / cxph[ix]) * tmp[iz][iy]
							- (mui * czm[iz] / cxph[ix]) * Bza[iz][iy][ix];
					Bza[iz][iy][ix] = tmp[iz][iy];
				}
				clf[iz][iy] = Ex[iz][iy][cxm] - Ex[iz][iy + 1][cxm]
						+ Ry[iz][iy] - Ey[iz][iy][cxm];
				tmp[iz][iy] = (cymh[iy] / cyph[iy]) * Bza[iz][iy][cxm]
						- (ch / cyph[iy]) * clf[iz][iy];
				Hz[iz][iy][cxm] = (cxmh[cxm] / cxph[cxm]) * Hz[iz][iy][cxm]
						+ (mui * czp[iz] / cxph[cxm]) * tmp[iz][iy]
						- (mui * czm[iz] / cxph[cxm]) * Bza[iz][iy][cxm];
				Bza[iz][iy][cxm] = tmp[iz][iy];
				for (int ix = 0; ix < cxm; ix++) {
					clf[iz][iy] = Ex[iz][cym][ix] - Ax[iz][ix]
							+ Ey[iz][cym][ix + 1] - Ey[iz][cym][ix];
					tmp[iz][iy] = (cymh[cym] / cyph[iy]) * Bza[iz][iy][ix]
							- (ch / cyph[iy]) * clf[iz][iy];
					Hz[iz][cym][ix] = (cxmh[ix] / cxph[ix]) * Hz[iz][cym][ix]
							+ (mui * czp[iz] / cxph[ix]) * tmp[iz][iy]
							- (mui * czm[iz] / cxph[ix]) * Bza[iz][cym][ix];
					Bza[iz][cym][ix] = tmp[iz][iy];
				}
				clf[iz][iy] = Ex[iz][cym][cxm] - Ax[iz][cxm] + Ry[iz][cym]
						- Ey[iz][cym][cxm];
				tmp[iz][iy] = (cymh[cym] / cyph[cym]) * Bza[iz][cym][cxm]
						- (ch / cyph[cym]) * clf[iz][iy];
				Hz[iz][cym][cxm] = (cxmh[cxm] / cxph[cxm]) * Hz[iz][cym][cxm]
						+ (mui * czp[iz] / cxph[cxm]) * tmp[iz][iy]
						- (mui * czm[iz] / cxph[cxm]) * Bza[iz][cym][cxm];
				Bza[iz][cym][cxm] = tmp[iz][iy];
			}
		}
                       // OMP USER CODE ENDS
                       if (iz == (__omp_WholeData2.stop-1)) amLast = true;
                     } // of for 
                     if(__omp_ChunkData1.startStep == 0)
                       break;
                     __omp_ChunkData1.start += __omp_ChunkData1.startStep;
                     __omp_ChunkData1.stop += __omp_ChunkData1.startStep;
                   } // of for(;;)
                   } // of while
                   // call reducer
                   jomp.runtime.OMP.doBarrier(__omp_me);
                   // copy lastprivate variables out
                   if (amLast) {
                   }
                 }
                 // set global from lastprivate variables
                 if (amLast) {
                 }
                 // set global from reduction variables
                 if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                 }
                 } // OMP FOR BLOCK ENDS

		}
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

