JAVA=/usr/lib/jvm/java-8-oracle/bin/java
PYJAMA=../lib/pyjama-v1.5.4b.jar
MAX_THREADS=16
FILE=../resuls.csv
declare -a benchmarks=("PDcorrelationPj" "PDcovariancePj" "PL2mmPj" "PL3mmPj" "PLataxPj" 
			"PLbicgPj" "PLcholeskyPj" "PLdoitgenPj" "PLdurbinPj" "PLdynprogPj" 
			"PLgemmPj" "PLgemverPj" "PLgesummvPj" "PLgramschmidtPj" "PLludcmpPj" 
			"PLluPj" "PLmvtPj" "PLsymmPj" "PLsyr2kPj" "PLsyrkPj" 
			"PSfdtd_2dPj" "PSfdtd_apmlPj" "PSjacobi_1d_imperPj" "PSjacobi_2d_imperPj" "PSseidel_2dPj" 
			"PLtrisolvPj" "PLtrmmPj" "PMfloydWarshallPj" "PMreg_detectPj" "PSadiPj")

#create new result file
if [ -f  $FILE ];
then
   rm $FILE
else
   touch $FILE
   echo "benchmark, nthreads, time" >> $FILE
fi

START_TIME=`date`
## now loop
for BENCHMARK in "${benchmarks[@]}"
do
 echo "benchmark" $BENCHMARK "is running.."
  for NUM_THREADS in $(seq 1 $MAX_THREADS);
  do
    #echo $JAVA -cp $PYJAMA:. $BENCHMARK STANDARD $NUM_THREADS
    echo "current number of threads" $NUM_THREADS
    echo "$BENCHMARK, $NUM_THREADS, `$JAVA -cp $PYJAMA:. $BENCHMARK STANDARD $NUM_THREADS`" >> $FILE
  done
done

echo "benchmark finished. started at $START_TIME, finished at `date`"
